#lang racket/base
(require slideshow/pict
         slideshow/base
         slideshow/code
         racket/list
         "colors.ss"
         "utils.ss"
         "alg.ss"
         "types.ss")

(provide num-rule plus-rule minus-rule
         var-rule func-rule apply-rule)

(define (num-rule)
  (code #,(E) #,(ts) #,(nonterm "Num") : _num))

(define (arith-rule plus)
  (infer (code #,(E) #,(ts) {#,plus #,(M 1) #,(M 2)} : _num)
         (ante-append
          (code #,(E) #,(ts) #,(M 1) : _num)
          (code #,(E) #,(ts) #,(M 2) : _num))))

(define (plus-rule) (arith-rule (code +)))
(define (minus-rule) (arith-rule (code -)))

(define (var-rule)
  (code #,(inenv (code #,(t "...") #,(tbind (nonterm "Sym") (T)) #,(t "..."))) #,(ts) #,(nonterm "Sym") : #,(T)))

(define (func-rule #:tvarcheck? [tvarcheck? #f])
  (infer (hbl-append
          (code #,(E) #,(ts) {lambda {[#,(nonterm "Sym") : #,(T 1)]} #,(M)})
          __ (code :) __ (code #,(-> (T 1) (T 2))))
         (let ([p (hbl-append
                   (code #,(E+ (E) (inenv (tbind (nonterm "Sym") (T 1)))))
                   __ (code #,(ts) #,(M) : #,(T 2)))])
           (if tvarcheck?
               (ante-append (code #,(E) #,(ts) #,(T 1))
                            p)
               p))))

(define (apply-rule #:subtype? [subtype? #f])
  (infer (code #,(E) #,(ts) {#,(M 1) #,(M 2)} : #,(T 3))
         (let ([p (ante-append 
                   (code #,(E) #,(ts) #,(M 1) : #,(-> (T (if subtype? 1 2)) (T 3)))
                   (code #,(E) #,(ts) #,(M 2) : #,(T 2)))])
           (if subtype?
               (ante-append p (code #,(T 2) #,(t "≤") #,(T 1)))
               p))))
