#lang racket/base
(require slideshow)

(provide problem
         add-gp-arrow)

(define (problem . a)
  (parameterize ([current-main-font 'roman])
    (apply item a)))

(define add-gp-arrow
  (lambda (p fxr fyr txr tyr)
    (let* ([to-left? #f]
           [w (pict-width p)]
           [h (pict-height p)]
           [fx (* w fxr)]
           [fy (* h fyr)]
           [tx (* w txr)]
           [ty (* h tyr)]
           [cx (* w (if to-left?
                        (/ (min fxr txr) 2)
                        (- 1 (/ (- 1 (max fxr txr)) 2))))]
           [cy (* h (/ (+ fyr tyr) 2))])
      (lt-superimpose
       p
       (colorize (inset (arrowhead gap-size (atan (- (- ty cy))
                                                  (- tx cx)))
                        (- tx (/ gap-size 2))
                        (- ty (/ gap-size 2))
                        0 0)
                 "orange")
       (colorize
        (linewidth
         3
         (dc (lambda (dc x y)
               (send dc draw-spline 
                     (+ x fx) (+ y fy)
                     (+ x cx) (+ y cy)
                     (+ x tx) (+ y ty)))
             w h 0 0))
        "orange")))))
