#lang slideshow

(provide in-file
         vfactor
         file-background)

(define file-background "lightblue")

(define vfactor 1.2)

(define (in-file name content)
  (define color file-background)
  (define border-color "black")
  (define name-box
    (if name
        (inset (scale (if (string? name)
                          (tt name)
                          name)
                      0.8)
               6 3)
        (blank)))
  (define background
    (colorize (filled-rectangle (+ (pict-width content) (current-font-size))
                                (+ (pict-height content) (current-font-size)))
              color))
  (define c
    (cc-superimpose
     (frame background)
     content))
  (define r
    (if name
        (let ([n name-box])
          (define f
            (cc-superimpose (frame
                             (colorize (filled-rectangle (pict-width n)
                                                         (pict-height n))
                                       "beige"))
                            n))
          (vr-append (inset f (min 0 (- (pict-width c) (pict-width f))) 0 0 0)
                     c))
        c))
  r)
